import xml.etree.ElementTree as etree
import openpyxl 

pre_defined_file = "C:/Users/zhe.sun/Desktop/Python解读res/pre_defined_name.xlsx"
wb = openpyxl.load_workbook(pre_defined_file)
wb.save('data_output.xlsx')
data_output = openpyxl.load_workbook('data_output.xlsx')

res_file = "C:/Users/zhe.sun/Desktop/Python解读res/vvt_parallel_travel.res"


def print_name(res_file, pre_defined_name_sheet):
    """
    将预定义的名称，写到临时字典pre_defined_name
    遍历res文件中的entity name，找到与预定义相同的名称，将名称及序号存到字典name_id中
    """
    pre_defined_name_sheet = wb[pre_defined_name_sheet]
    rows = pre_defined_name_sheet.rows
    columns = pre_defined_name_sheet.columns

    pre_defined_name = {}
    pre_defined_name.setdefault('entity',[])
    pre_defined_name.setdefault('component',[])
    for col in columns:
        col_val = [row.value for row in col]
        pre_defined_name.setdefault('entity',[])
        pre_defined_name['entity'].append(col_val[0])
        pre_defined_name['component'].append(col_val[1])
    
    tree = etree.parse(res_file)
    root = tree.getroot()

    a = len(pre_defined_name['entity'])
    name_id = {'entity':[None for i in range(a)],'component':[None for i in range(a)],'units':[None for i in range(a)],'id':[None for i in range(a)]}

    for name_son in root[1][3]:
        if name_son.attrib['name'] in pre_defined_name['entity']:
            for name_grandson in name_son:
                for i in range(a):
                    if pre_defined_name['entity'][i] == name_son.attrib['name']:
                        if name_grandson.attrib['name'] == pre_defined_name['component'][i]:
                            name_id['entity'][i] = (name_son.attrib['name'])
                            name_id['component'][i] = (name_grandson.attrib['name'])
                            name_id['units'][i] = (name_grandson.attrib['unitsValue'])
                            name_id['id'][i] = (name_grandson.attrib['id'])
    return name_id


def print_data(file_name,data_output_sheet_name,name_id):

    """
    遍历res文件中的data，将其存放到临时字典中，找到相应的顺序，输出
    需要数据格式从字符串转换数字
    """
    tree = etree.parse(res_file)
    root = tree.getroot()

    data_output_sheet = wb[data_output_sheet_name]
    a = len(name_id['entity'])
    temp = []
    j = 2
    for data_son in root[1][5]:
        j = j+1
        lines = data_son.text.splitlines()
        for line in lines:
            temp.extend(line.split())
        for i in range(a):
            index = int((name_id['id'][i]))
            index = index-1
            t = (temp[index])
            if name_id['units'][i] == 'rad':
                t = float(t)*57.3
            else:
                t = float(t)

            data_output_sheet.cell(row = j,column = i+1,value = "{:.6f}".format(t)).data_type = "int"

        temp.clear()
    
    wb.save('data_output.xlsx')
    wb.close()

    return

name_id = print_name(res_file,"vvt")
print_data(res_file,"vvt",name_id)

